/*****************************************************************************
 ** Class Export::Ssa
 **
 ** This class handles the export filter for srt (subtitle) files
 **
 **   Created : Tue Nov 9 07:53:05 2004
 **        by : Varol Okan using the kate editor
 ** Copyright : (c) Varol Okan
 **   License : GPL v 2.0
 **
 **
 *****************************************************************************/

#ifndef __EXPORT_SSA_H__
#define __EXPORT_SSA_H__

#include "exportsrt.h"
#include "sourcefileentry.h"

namespace Export
{

class Ssa : public BaseSubtitle
{
public:
   Ssa ( );
  virtual ~Ssa ( );

  virtual bool exportSub ( Subtitles * );
  virtual bool writeFile ( Subtitles *, QString & );

private:
  void writeScriptInfo ( QTextStream & );
  void writeStyles     ( QTextStream & );
  void writeEvents     ( QTextStream & );
  QString toAbgr       ( Rgba        & );

private:
  Subtitles *m_pSubtitles;
};

}

#endif // __EXPORT_SSA_H__
